      program input_setup

c code to generate the input files for running exclurad on the cluster
c it assumes a set of values for phi_pq and you assign the range in
c cos(theta_pq) and choose the values for W and Q2.
c                                          - gpg 4/26/04

      implicit none

      character*100 line(12)
      character*30 filename

      integer i,j,ncases

      real startx, stopx, step, costheta

      line(1) =  "4       !  1: AO 2: maid98  3: maid2000 4: deep"
      line(2) =  "0	  !  0: Full, 1: Factorizable and Leading log " 
      line(3) =  "4.232   !  bmom - lepton momentum"
      line(4) =  "0.0     !  tmom - momentum per nucleon"
      line(5) =  "1       !  lepton - 1 electron, 2 muon"
      line(6) =  "2       !  ivec - detected hadron (2) proton always"
      line(7) =  "0.310   !  vcut - cut on v. (0.) if no cut, negative -- v"
      line(8) =  "13"
      line(9) =  "2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041 2.2041" 
      line(10) = "1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5    1.5  "
c      line(11) = "0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998  0.998"
      line(12) = "0.0    15.0   30.0   45.0   60.0   75.0   90.0   105.0  120.0  135.0  150.0  165.0  180.0" 
c 
c set the numbers that define the values of cos(theta_pq) here.
c
      ncases = 1
      startx = -1.0
      stopx = 1.0
      step = (stopx-startx)/float(ncases)

      do i = 0,ncases

         costheta = startx + float(i)*step
         
         if (i.lt.10) then
            write (unit=filename,fmt=100) i
 100        format('input/input0',i1,'.dat')
            print *,filename
         else
            write (unit=filename,fmt=110) i
 110        format('input/input',i2,'.dat')
            print *,filename
         end if
         open(unit=1,name=filename,type='unknown')
         do j=1,10
            write (1,*) line(j)
         end do
         write (1,120) costheta,costheta,costheta,costheta,costheta,
     1                 costheta,costheta,costheta,costheta,costheta,
     2                 costheta,costheta,costheta
 120     format(13(f6.3,' '))
         write (1,*) line(12)
         close(unit=10)

      end do

      print *,' '
      print *,'ACHTUNG!!!'
      print *,' '
      print *,'Make sure you have removed any old files from the input'
      print *,'directory. If you have not done that, do it now and'
      print *,'rerun input_setup.'

      stop
      end
