#!/usr/bin/perl
# 
# script for running on a slave node of the cluster.
# called from submit_exclurad.pl. 
#                                      - gpg 4/26/04
#
# set up the environment including the node and run 
# number assignments that come from the arguments of the
# script.

@option  = @ARGV;
$options = @option;

$NODE =  $option[0];
$INPUT_FILE = $option[1];
$CASE = $option[2];

system("setenv NO_LOCAL 1");

# Make a working directory and go to it
# NOTE: Make this on the master as well as a place holder
# no actual data goes to the placeholder on the master.

system("date >> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("bpsh $NODE rm -r /scratch/gilfoyle/exclurad/ >| /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("bpsh $NODE mkdir -p /scratch/gilfoyle/exclurad >| /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("cd /scratch/gilfoyle/exclurad/");

# move the appropriate input data to the slave node unless you're using files
# that are already on the slave.

system("echo 'Copy the input file.'>> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("bpsh $NODE cp /home/gilfoyle/eod/exclurad/run/input/$INPUT_FILE /scratch/gilfoyle/exclurad/input.dat");
system("bpsh $NODE cp /home/gilfoyle/eod/exclurad/wvo_proton/wave_IIB_new.dat /scratch/gilfoyle/exclurad/wave_IIB_new.dat");

# More housekeeping and monitoring information.

system("cd /scratch/gilfoyle/exclurad/");
chdir("/scratch/gilfoyle/exclurad/");
system("date >> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("pwd  >>  /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");

# run exclurad. select the version of exclurad by commenting out the unwanted ones
# and removing the comment on the desired version.

system("echo 'run exclurad.'>> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("bpsh $NODE /home/gilfoyle/eod/exclurad/wvo_proton/exclurad_wvo_p_Linux >> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");
system("date >> /scratch/gilfoyle/exclurad/rc_log${NODE} 2>&1");

# Copy output file back to the master and clean up the slave directory.
# Do this here instead of in submit_eodc.pl so that root is done before
# we start cleaning up.

if (${CASE} < 10) {
    system("bpcp ${NODE}:/scratch/gilfoyle/exclurad/radcor.dat /home/gilfoyle/eod/exclurad/run/results/radcor0${CASE}.dat");
}
if (${CASE} > 9) {
    system("bpcp ${NODE}:/scratch/gilfoyle/exclurad/radcor.dat /home/gilfoyle/eod/exclurad/run/results/radcor${CASE}.dat");
}
chdir("/home/gilfoyle/exclurad/run/");
