#!/usr/bin/perl
#
# script to run multiple cases of exclurad on the Richmond cluster. it 
# copies input data to a slave node and copies the results back to the
# master. it does NOT use beomap to allocate node numbers; it
# just picks them in numerical order and skips any down nodes.
#                                          - gpg
# run this by executing 'submit_exclurad.pl' at the 
# command line.
#
# do housekeeping on the master and the slaves.
#
system("rm /home/gilfoyle/eod/exclurad/run/results/*");
system("rm /scratch/gilfoyle/exclurad/*");
#
# stuff for picking the static slave node.
#
@filelist = glob("input/*");
$number_of_nodes_needed=@filelist;
#$number_of_nodes_needed=41;
$first_node=0;
#
# list of down nodes.
#
@dead_nodes = (13,22,30,36,37,38,41,45);
$number_of_dead_nodes = @dead_nodes;
#
# initialize parameters. 
#
$job=0;
$skipped_nodes=0;
#
# get the run number and select the slave node.
#
for ($i=0; $i < $number_of_nodes_needed; $i++) {

    if ($i < 10) {
	$input_file = "input0$i.dat";
    }
    if ($i > 9) {
	$input_file = "input$i.dat";
    }
#
# get the node number and be careful about skipping the bad ones.
#
    $node=($first_node+$job+$skipped_nodes);
#
# skip bad nodes.
#
    for ($j = 0; $j < $number_of_dead_nodes; $j++) {
	if ($node == $dead_nodes[$j]) {
	    print("Skipping node $node.\n");
	    $node++;
	    $skipped_nodes++;
	}
    }
    print "\n Selected slave node $node.\n";
#
# get the batch command file ready to submit the job and let're rip. 
# clean up is done in run_exclurad_on_node.pl since we have to wait for 
# the job to get done on the slave.
#
    open(OUT,">run_job");
    print OUT "./run_exclurad_on_node.pl $node $input_file $i \n";
    print     "./run_exclurad_on_node.pl $node $input_file $i \n";
    close(OUT);
#
# batch command to queue a using file run_job.
#
    system("batch -q a -f run_job");
    print "Sleep for 5 seconds.\n";
    sleep 5;
    print "Submit on node $node EXCLURAD.\n";
#
# go to the next job.
#
    $job++;
}
