      subroutine deep(sig_t,sig_l,sig_tt,sig_lt,sig_ltp)
c*****deep
c
c     This program produces response functions for deuteron
c     electrodisintigration.
c
      implicit real*8 (a-h,o-z)
c
      dimension resp(0:8,0:3,9),respp(100,0:8,0:3,9),thta(100)
c
      real*8 mn,mt,Md,Md2,Ebeam,Eprime,MdMeV
      real   sig_t,sig_tt,sig_l,sig_lt,sig_ltp
      common/dpara/mn,mt
c                                                           
      parameter(nwave=4,mndata=64)
      dimension aq(mndata),zdata(mndata,nwave),wt(mndata),rwave(4)
      dimension zp(4)
c
      parameter(pi=3.141592653589793,alpha_qed=1.d0/137.036d0)
      parameter(hbarc=197.33)
c
      include "deep_input.inc"
      x = deep_x

 1    format(a20)
 2    format(9(2x,1pe20.10))
c
      mn=938.9d0
      mt=2.d0*mn-2.2246d0
      Md=1.875611
      alpha=.729735d-2
c
      call deep_setup(filename,ipwave,inorm)
c
c      sum=0.0
c      do i=0,100
c	  p_mev=i*40.      
c	  p_fm=p_mev/hbarc
c        call wav(p_mev,zp)
c	  sum=sum+40.0*p_mev**2*(zp(1)**2+zp(2)**2+zp(3)**2+zp(4)**2)
c	  write(6,2) p_fm,zp*sqrt(hbarc**3)*1.01
c	end do
c	  sum=sum/(8.*pi**3)
c	  print *,' sum=',sum
c	stop
c
      if(i_master.eq.0) then
c
cgpg        print *,' Response functions at constant x and Q^2'
cgpg        print *
cgpg        print *,' x=',x
cgpg        print *,' Q^2 (GeV)^2)', q2gev
cgpg        print *,' iff=',iff
cgpg        print *,' nthta=',nthta
c  
        q2=q2gev*1.d6
c
        omega_l=q2/(2.d0*mn*x)
        q_l=sqrt(q2+omega_l**2)
        w=sqrt(mt**2+2.*mt*omega_l-q2)
c       
cgpg        print *
cgpg        print *,' omega_l=',omega_l,' q_l=',q_l
cgpg        print *,' W=',w
cgpg        print *
c
cgpg        for neutron case use 180 - theta_pq
        if (nthta .eq. 1) then
           thetac = pi + theta_pq
           i=1
           thta(i)=thetac*180.d0/pi
c
c the zero in the next call selects cm frame.
c
           call respns(x,q2,thetac,iff,iexch,0,resp)
c
           do iresp=1,9
              do inuc=0,3
                 do ideu=0,8
                    respp(i,ideu,inuc,iresp)=resp(ideu,inuc,iresp)
                 end do
              end do
           end do
        else
           do  i=1,nthta
              thetac=dfloat(i-1)*pi/dfloat(nthta-1)
c              if(i.eq.1) thetac=1.d-10
c              if(i.eq.nthta) thetac=pi-1.d-10
              thta(i)=thetac*180.d0/pi
c
              call respns(x,q2,thetac,iff,iexch,0,resp)
c
              do iresp=1,9
                 do inuc=0,3
                    do ideu=0,8
                       respp(i,ideu,inuc,iresp)=resp(ideu,inuc,iresp)
                    end do
                 end do
              end do
           end do
        end if
c
c output for deep.

        R_t   = respp(1,0,0,2)
        R_l   = respp(1,0,0,1)
        R_tt  = respp(1,0,0,3)
        R_lt  = respp(1,0,0,4)
        R_ltp = respp(1,0,0,5)

c now translate these structure functions into the form used by
c Afanasev et al. the notation here is taken from Gross and 
c Dmitrasinovic, PR C40, 2479 and J.Adam, et al nucl-th/0204068. 
c see notebook eod7.

        Md2 = (Md)**2
        W2MeV = W**2
        W2 = (W*1.0e-03)**2

cgpg compare with mathematica notebook.

cgpg        Q2mev = 3.0*10**6
cgpg        xBJ = 1.0
cgpg        xMn = 0.939*10**3
        MdMeV = 1.876*10**3
        nu = omega_l
cgpg        xqL = sqrt(Q2 + xnu**2)
        Ebeam = E_beam_gev*1000
        Eprime = Ebeam - nu
cgpg        xthetae = 2.0*asin( sqrt(Q2/(4*Ebeam*Eprime)) )
        thetae = theta_e_deg*pi/180
cgpg        xW2mev = W2*10**6
cgpg        print *,nu,Ebeam,Eprime,thetae,theta_e_deg,xthetae
cgpg        print *,q_l,Mn,W2MeV,MdMeV,Q2,W
cgpg        stop
        pcm = 0.5*sqrt(W2MeV - (4*Mn*Mn))
        factor1 = Q2/(4*pi*MdMeV*q_l*q_l)
        sigmaMott = alpha*cos(thetae/2)/
     1                  (2*Ebeam*sin(thetae/2)*sin(thetae/2))
        sigmaMott = sigmaMott**2
        recoil = Eprime/Ebeam
        zeta2 = (q_l**2/Q2)*(tan(thetae/2))**2
        sT = 0.5 + zeta2
        sLT = -0.5*sqrt(1 + zeta2)
        convert2mb = 38809*10
        xsigma = pcm*sigmaMott*factor1*recoil*(R_L + sT*R_T + 
     1           R_TT + sLT*R_LT)*convert2mb

        wvoN0 = pcm*sigmaMott*factor1
        epsilon = 1 + 2*(1 + (nu*nu/Q2))*tan(thetae/2)
        epsilon = 1/epsilon
        aaN0 = alpha*Eprime*(W2MeV - MdMeV**2)/
     1                   (2*pi*Ebeam*2*MdMeV*Q2*(1-epsilon))

cgpg        print *,'W=',sqrt(xW2mev),' thetae=',xthetae*180/pi
cgpg        print *,pcm,sigmaMott,factor1,recoil
cgpg        print *,'sigma=',xsigma,'  ********************'

        convert2GeV = 1000
cgpg        sig_L = alpha*(1/sqrt(W2-Md2))*R_L*convert2GeV
cgpg        sig_T = (alpha/2)*(1/sqrt(W2-Md2))*R_T*convert2GeV
cgpg        sig_LT = -alpha*(1/sqrt(W2-Md2))*R_LT*convert2GeV
cgpg        sig_TT = (-alpha/2)*(1/sqrt(W2-Md2))*R_TT*convert2GeV
cgpg        sig_LTp = -alpha*sqrt(2.0)*(1/sqrt(W2-Md2))*R_LTp*convert2GeV

        sig_L = convert2mb*convert2GeV*wvoN0*R_L/(aaN0*epsilon)
        sig_T = convert2mb*convert2GeV*wvoN0*sT*R_T/(aaN0)
        sig_LT = convert2mb*convert2GeV*wvoN0*sLT*R_LT/
     1                        (aaN0*sqrt(epsilon*(1+epsilon)*0.5))
        sig_TT = -convert2mb*convert2GeV*wvoN0*R_TT/(2*aaN0*epsilon)
        sig_LTp = 0.0

cgpg        print *,Ebeam,Eprime,Q2GeV
cgpg        print *,'responses:',R_T,R_L,R_LT,R_TT,R_LTp
cgpg        print *, bmom,Md,Eprime,theta_e
cgpg        print *,'sigmas:',sig_T,sig_L,sig_LT,sig_TT,sig_LTp
cgpg        print *,'alpha=',alpha,' W2=',W2,' Md2=',Md2

cgpg        stop

        call nuc_write(nthta,thta,respp,q2gev,6)
c
cgpg        open(unit=nfile+1,file='deep.out',status='new')
c
cgpg        call nuc_write(nthta,thta,respp,q2gev,nfile+1)
c
      else if(i_master.eq.1) then   ! this doesn't seem to work 
c
        E_beam=E_beam_gev*1.d3
        E_scat=E_scat_gev*1.d3
c
        print *,' cross section'
        print *
        print *,' E_beam (GeV)',E_beam_gev
        print *,' E_scat (GeV)',E_scat_gev
        print *,' theta_e_deg',theta_e_deg
        print *,' iff=',iff
        print *
c
        omega_l=e_beam-e_scat
        theta_e=pi*theta_e_deg/180.0d0
        q2=4.*E_beam*E_scat*sin(0.5d0*theta_e)**2
c        print *,omega_l,theta_e,q2
        q_l=sqrt(q2+omega_l**2)
c
        print *,' omega_l=',omega_l,' q_l=',q_l
        print *
c
        do i=1,120
          p_r=5.d0*i
          e_l=mt+omega_l-sqrt(p_r**2+mn**2)
c          print *,' e_l=',e_l
c          print *
          p_l=sqrt(e_l**2-mn**2)
c          print *,' p_l=',p_l
c          print *
          csth_l=(q_l**2+p_l**2-p_r**2)/(2.*q_l*p_l)
c	    print *,csth_l
c          print *,' csth_l=',csth_l
c          print *
          theta_l=acos(polar_range(csth_l))
          theta_l_deg=180.d0*theta_l/pi
c          theta_l=0.282*i+0.00001
c          print *,E_beam,E_scat,theta_e_deg,theta_l_deg
c          print *
          call x_section(E_beam,E_scat,theta_e_deg,theta_l_deg,iff,
     &                   iexch)
        end do
	else if (i_master.eq.2) then
	  E_beam=E_beam_gev_a*1.d3
	  T_p=T_p_GeV*1.d3
c
        print *,' cross section'
        print *
	  print *,' E_beam=',E_beam
	  print *,' T_p=',T_p
	  print *,' theta_m_deg=',theta_m_deg
        print *,' iff=',iff
        print *
	  print *,' theta_l_deg        p_r_l    cross_section',
     &          '   sigma_mott     recoil'
c
	  do i=1,120
	    p_r=5.d0*i
	    e_r=sqrt(p_r**2+mn**2)
	    p_l=sqrt(t_p**2+2.*mn*t_p)
	    omega_l=t_p+mn+e_r-mt
	    E_scat=E_beam-omega_l
	    q_l=p_r*cos(theta_m_deg*pi/180.d0)+sqrt(p_l**2
     &       -p_r**2*sin(theta_m_deg*pi/180.d0)**2)
	    q2=q_l**2-omega_l**2
	    theta_e_deg=2.*asin(sqrt(q2/4.d0/E_beam/E_scat))*180.d0/pi
	    theta_l_deg=asin(p_r*sin(theta_m_deg*pi/180.d0)/
     &                p_l)*180.d0/pi
c	    print *,' p_r=',p_r,' omega_l=',omega_l,' q_l=',q_l
c          print *,' E_scat=',E_scat,' theta_e_deg=',theta_e_deg,
c	&            ' theta_l_deg=',theta_l_deg
          call x_section(E_beam,E_scat,theta_e_deg,theta_l_deg,iff,
     &                   iexch)
	  end do
      end if
c
c      stop
      return
      end
c
c_______________________________________________________________________
c
c*****nuc_write
c
c     This subroutine writes the nucleon polarization response functions.
c
      subroutine nuc_write(nthta,thta,respp,q2gev,nunit)
c
      implicit none
c
      real*8 q2gev,respp(100,0:8,0:3,9),thta(100)
      real*8 struc_func(5)
c
      integer i,ideu,inuc,iresp,nthta,j,nunit
c
      character*1 pol(0:3)
      data pol/' ','n','s','l'/
c
 1    format('  x=',1pe12.4,' q2gev=',1pe12.4,/)
 2    format(6(2x,1pe12.4),16x,a1)
 3    format(14x,5(2x,1pe12.4),16x,a1)
 4    format(42x,4(2x,1pe12.4),2x,a1)
 5    format(7x,'theta',10x,'R_L',10x,'R_T',10x,'R_TT',10x,'R_LT',
     &       8x,'R_LTprime',6x,'R_Tprime')
c
cgpg      write(nunit,5)
      ideu=0
c
      do i=1,nthta
c
        inuc=0
cgpg        write(nunit,2) thta(i),(respp(i,ideu,inuc,iresp),iresp=1,5),
cgpg     &             pol(inuc)
        do iresp=1,5
           struc_func(iresp) = respp(i,ideu,inuc,iresp)
        end do
cgpg        write (nunit,2) thta(i),(struc_func(iresp),iresp=1,5),pol(inuc)
c
cgpg        inuc=1
cgpg        write(nunit,3)(respp(i,ideu,inuc,iresp),iresp=1,5),pol(inuc)
c
cgpg        do inuc=2,3
cgpg          write(nunit,4)(respp(i,ideu,inuc,iresp),iresp=6,9),pol(inuc)
cgpg        end do
c
      end do
      return
      end
 
 
 
