c______________________________________________________________________
c
c*****ff_nuc.f
c
c     This function generates the off-shell nucleon form factor.
c
c     INPUT
c           psq.....................square of invariant nucleon mass
c           ff_nuc_mass.............nucleon form factor mass\
c           i_ff_exp................power of form factor
c           i_ff_type...............type of form factor
c                    =0.............old version of form factor
c                    =0.............new flat version of form factor
c
c     OUTPUT
c           ff_nuc..................off-shell nucleon form factor h(p^2)
c
      function ff_nuc(psq,ff_nuc_mass,i_ff_exp,i_ff_type)
c
      implicit real*8(a-h,o-z)
c
      real*8 mn,mt
      common/dpara/mn,mt
c
      ff_mass_sqr=ff_nuc_mass**2
c
      if(i_ff_type.eq.0) then
c
        ff_nuc=2.*(ff_mass_sqr-mn**2)**2/((ff_mass_sqr-psq)**2+
     &       (ff_mass_sqr-mn**2)**2)
c
      else if(i_ff_type.eq.1) then
c
        ff_nuc=(ff_mass_sqr-mn**2)**2/((mn**2-psq)**2+
     &       (ff_mass_sqr-mn**2)**2)
c
      else
        print *,' Illegal nucleon form factor'
        stop
      end if
c
c
      ff_nuc=ff_nuc**i_ff_exp
c
      return
      end
