c*****k_factors.f
c
c     This subroutine generates the kinematic factors for the cross section
c
      subroutine k_factors(ql,Q,theta_e,phi,s_k,a_k)
c
      implicit real*8 (a-h,o-z)
c
      dimension s_k(6),a_k(9)
c
      parameter(root2=1.414213562373095,root2i=1.d0/root2)
c
      xsi=ql*tan(theta_e/2.)/Q
      xsi2=xsi**2
c
      s_k(1)=1.d0
      s_k(2)=0.5d0+xsi2
c
      s_k(3)=-0.5d0
      s_k(4)=-root2i*sqrt(1.+xsi2)
      s_k(5)=-root2i*xsi
      s_k(6)=xsi*sqrt(1.+xsi2)
c
      a_k(1)=1.d0
      a_k(2)=1.d0
      a_k(3)=cos(2.*phi)
      a_k(4)=cos(phi)
      a_k(5)=sin(phi)
      a_k(6)=sin(2.d0*phi)
      a_k(7)=sin(phi)
      a_k(8)=cos(phi)
      a_k(9)=1.d0
c
      return
      end
     